import {DataRectangle} from "@/types";
import {DeepReadonly} from "vue";

const areDifferent = (vModel: DataRectangle[][], storeModel: DeepReadonly<DataRectangle[][]>) => {
    if (vModel.length !== storeModel.length) {
        return true
    }

    let isDifferent = false
    for (const vModelElement of vModel) {
        for (const dataRectangle of vModelElement) {
            const storeModelElement = storeModel.find((element) =>
                element.find((element) => {
                    const dataRectangleKeys = Object.keys(dataRectangle)
                    const elementKeys = Object.keys(element)
                    if (dataRectangleKeys.length !== elementKeys.length) {
                        return false
                    }
                    for (const key of dataRectangleKeys) {
                        if (dataRectangle[key] !== element[key]) {
                            return false
                        }
                    }
                    return true
                }))
            if (storeModelElement) {
                continue
            }
            isDifferent = true
        }
    }
    return isDifferent
}

export default function () {
    return {
        areDifferent,
    }
}
